package com.usky.transfer.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 创建下发命令历史记录表
 * </p>
 *
 * @author ya
 * @since 2024-09-24
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class DmpDeviceCommand implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 产品编码
     */
    private String productCode;

    /**
     * 设备Uuid
     */
    private String deviceUuid;

    /**
     * 下发命令内容
     */
    private String commandContent;

    /**
     * 下发命令响应内容
     */
    private String commandResponse;

    /**
     * 命令状态;0 命令执行中，1 命令成功，2 命令失败
     */
    private Integer commandStatus;

    /**
     * 创建人
     */
    private String createdBy;

    /**
     * 创建时间
     */
    private LocalDateTime createdTime;

    /**
     * 更新人
     */
    private String updatedBy;

    /**
     * 更新时间
     */
    private LocalDateTime updatedTime;

    /**
     * 组织结构ID
     */
    private Integer deptId;

    /**
     * 租户ID
     */
    private Integer tenantId;

    /**
     * 操作人
     */
    private String userName;

    /**
     * 操作人Id
     */
    private Long userId;


}
